// Fig. 23.5: RunnableTester.java
// Impresso de mltiplas threads em diferentes intervalos.
import java.util.concurrent.Executors;
import java.util.concurrent.ExecutorService;

public class ExecutorTeste
{
   public static void main( String[] args )
   {
      // cria e nomeia cada executvel
      PrintTask task1 = new PrintTask( "thread1" );
      PrintTask task2 = new PrintTask( "thread2" );
      PrintTask task3 = new PrintTask( "thread3" );
        
      System.out.println( "Starting threads" );
        
      // cria ExecutorService para gerenciar threads
      ExecutorService threadExecutor = Executors.newFixedThreadPool( 3 );

      // inicia threads e coloca no estado executvel
      threadExecutor.execute( task1 ); // inicia task1
      threadExecutor.execute( task2 ); // inicia task2
      threadExecutor.execute( task3 ); // inicia task3

      threadExecutor.shutdown(); // encerra as threads trabalhadoras
        
      System.out.println( "Threads started, main ends\n" );
   } // fim do main
} // fim da classe RunnableTester 


/**************************************************************************
 * (C) Copyright 1992-2005 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
