public class ThreadSimples {

    //mostra uma msg, precedida pelo nome da thread corrent
    static void ThreadMsg(String message) {
        String threadName = Thread.currentThread().getName();
        System.out.format("%s: %s%n", threadName, message);
    }

    private static class Millor2 implements Runnable {
        public void run() {
            String perolas[] = {
                "Jamais diga uma mentira que nao possa provar",
                "Lutar pela paz eh como roubar pela honestidade",
                "Jamais converse com um policial, a nao ser em legitima defesa",
                "Por mais agil que seja, um politico sempre acaba comentendo alguma sinceridade"
            };
            try {
                for (int i = 0; i < perolas.length; i++) {
                    //Pausa por 2 segundos
                    Thread.sleep(4000);
                    //Imprime mensagem
                    ThreadMsg(perolas[i]);
                }
            } catch (InterruptedException e) {
                ThreadMsg("Hei.. eu nao terminei!");
            }
        }
    }

    public static void main(String args[]) throws InterruptedException {


        //espera, em milisegundos, antes de interromper Millor2
        //thread (default uma hora).
        long patience = 1000 * 60 * 60;

        //argumento passado eh em segundos....
        if (args.length > 0) {
            try {
                patience = Long.parseLong(args[0]) * 1000;
            } catch (NumberFormatException e) {
                System.err.println("Argument must be an integer.");
                System.exit(1);
            }

        }

        ThreadMsg("Iniciando thread Millor2");
        long startTime = System.currentTimeMillis();
        Thread t = new Thread(new Millor2());
        t.start();

        ThreadMsg("Esperando que a thread Millor2 termine");
        //Entra em loop ate que a thread  Millor2 acabe
        while (t.isAlive()) {
            ThreadMsg("ainda esperando...");
            //Espera ate um segundo para a thread t morrer
            t.join(1000);
            if (((System.currentTimeMillis() - startTime) > patience) &&
                    t.isAlive()) {
                ThreadMsg("cansado de esperar!");
                // interrompe a thread t. Isso faz com que ela seja terminada..
                t.interrupt();
                // espera que a thread millor2 morra.. a eu (main) prossigo
                t.join();
            }

        }
        ThreadMsg("finalmente acabou!");
    }
}

